/*
 * This file generated automatically from xwm.xml by c_client.py.
 * Edit at your peril.
 */

/**
 * @defgroup XCB_XWM_API XCB XWM API
 * @brief XWM XCB Protocol Implementation.
 * @{
 **/

#ifndef __XWM_H
#define __XWM_H

#include "xcb.h"
#include "xproto.h"

#ifdef __cplusplus
extern "C" {
#endif

#define XCB_XWM_MAJOR_VERSION 1
#define XCB_XWM_MINOR_VERSION 1

extern xcb_extension_t xcb_xwm_id;

/**
 * @brief xcb_xwm_query_version_cookie_t
 **/
typedef struct xcb_xwm_query_version_cookie_t {
    unsigned int sequence;
} xcb_xwm_query_version_cookie_t;

/** Opcode for xcb_xwm_query_version. */
#define XCB_XWM_QUERY_VERSION 0

/**
 * @brief xcb_xwm_query_version_request_t
 **/
typedef struct xcb_xwm_query_version_request_t {
    uint8_t  major_opcode;
    uint8_t  minor_opcode;
    uint16_t length;
    uint32_t major_version;
    uint32_t minor_version;
} xcb_xwm_query_version_request_t;

/**
 * @brief xcb_xwm_query_version_reply_t
 **/
typedef struct xcb_xwm_query_version_reply_t {
    uint8_t  response_type;
    uint8_t  pad0;
    uint16_t sequence;
    uint32_t length;
    uint32_t major_version;
    uint32_t minor_version;
} xcb_xwm_query_version_reply_t;

/** Opcode for xcb_xwm_set_virtual_vblank_interval. */
#define XCB_XWM_SET_VIRTUAL_VBLANK_INTERVAL 1

/**
 * @brief xcb_xwm_set_virtual_vblank_interval_request_t
 **/
typedef struct xcb_xwm_set_virtual_vblank_interval_request_t {
    uint8_t  major_opcode;
    uint8_t  minor_opcode;
    uint16_t length;
    uint32_t interval_ms;
} xcb_xwm_set_virtual_vblank_interval_request_t;

/** Opcode for xcb_xwm_add_display. */
#define XCB_XWM_ADD_DISPLAY 2

/**
 * @brief xcb_xwm_add_display_request_t
 **/
typedef struct xcb_xwm_add_display_request_t {
    uint8_t  major_opcode;
    uint8_t  minor_opcode;
    uint16_t length;
    int32_t  id;
    int16_t  x;
    int16_t  y;
    uint16_t width;
    uint16_t height;
    uint16_t rotation;
} xcb_xwm_add_display_request_t;

/** Opcode for xcb_xwm_remove_display. */
#define XCB_XWM_REMOVE_DISPLAY 3

/**
 * @brief xcb_xwm_remove_display_request_t
 **/
typedef struct xcb_xwm_remove_display_request_t {
    uint8_t  major_opcode;
    uint8_t  minor_opcode;
    uint16_t length;
    int32_t  id;
} xcb_xwm_remove_display_request_t;

/** Opcode for xcb_xwm_set_mode. */
#define XCB_XWM_SET_MODE 4

/**
 * @brief xcb_xwm_set_mode_request_t
 **/
typedef struct xcb_xwm_set_mode_request_t {
    uint8_t  major_opcode;
    uint8_t  minor_opcode;
    uint16_t length;
    int32_t  id;
    uint16_t width;
    uint16_t height;
    uint16_t rotation;
    uint16_t refreshRate;
} xcb_xwm_set_mode_request_t;

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_xwm_query_version_cookie_t
xcb_xwm_query_version (xcb_connection_t *c,
                       uint32_t          major_version,
                       uint32_t          minor_version);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will cause
 * a reply to be generated. Any returned error will be
 * placed in the event queue.
 */
xcb_xwm_query_version_cookie_t
xcb_xwm_query_version_unchecked (xcb_connection_t *c,
                                 uint32_t          major_version,
                                 uint32_t          minor_version);

/**
 * Return the reply
 * @param c      The connection
 * @param cookie The cookie
 * @param e      The xcb_generic_error_t supplied
 *
 * Returns the reply of the request asked by
 *
 * The parameter @p e supplied to this function must be NULL if
 * xcb_xwm_query_version_unchecked(). is used.
 * Otherwise, it stores the error if any.
 *
 * The returned value must be freed by the caller using free().
 */
xcb_xwm_query_version_reply_t *
xcb_xwm_query_version_reply (xcb_connection_t                *c,
                             xcb_xwm_query_version_cookie_t   cookie  /**< */,
                             xcb_generic_error_t            **e);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will not cause
 * a reply to be generated. Any returned error will be
 * saved for handling by xcb_request_check().
 */
xcb_void_cookie_t
xcb_xwm_set_virtual_vblank_interval_checked (xcb_connection_t *c,
                                             uint32_t          interval_ms);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_void_cookie_t
xcb_xwm_set_virtual_vblank_interval (xcb_connection_t *c,
                                     uint32_t          interval_ms);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will not cause
 * a reply to be generated. Any returned error will be
 * saved for handling by xcb_request_check().
 */
xcb_void_cookie_t
xcb_xwm_add_display_checked (xcb_connection_t *c,
                             int32_t           id,
                             int16_t           x,
                             int16_t           y,
                             uint16_t          width,
                             uint16_t          height,
                             uint16_t          rotation);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_void_cookie_t
xcb_xwm_add_display (xcb_connection_t *c,
                     int32_t           id,
                     int16_t           x,
                     int16_t           y,
                     uint16_t          width,
                     uint16_t          height,
                     uint16_t          rotation);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will not cause
 * a reply to be generated. Any returned error will be
 * saved for handling by xcb_request_check().
 */
xcb_void_cookie_t
xcb_xwm_remove_display_checked (xcb_connection_t *c,
                                int32_t           id);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_void_cookie_t
xcb_xwm_remove_display (xcb_connection_t *c,
                        int32_t           id);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 * This form can be used only if the request will not cause
 * a reply to be generated. Any returned error will be
 * saved for handling by xcb_request_check().
 */
xcb_void_cookie_t
xcb_xwm_set_mode_checked (xcb_connection_t *c,
                          int32_t           id,
                          uint16_t          width,
                          uint16_t          height,
                          uint16_t          rotation,
                          uint16_t          refreshRate);

/**
 *
 * @param c The connection
 * @return A cookie
 *
 * Delivers a request to the X server.
 *
 */
xcb_void_cookie_t
xcb_xwm_set_mode (xcb_connection_t *c,
                  int32_t           id,
                  uint16_t          width,
                  uint16_t          height,
                  uint16_t          rotation,
                  uint16_t          refreshRate);


#ifdef __cplusplus
}
#endif

#endif

/**
 * @}
 */
